/* 
 * Drone control system
 *
 * Pin layout:
 *  Control             -> Arduino
 *   - 5V               -> 5V
 *   - GND              -> GND
 *   - AUX1/FLIGHTMODE  -> PWM6
 *   - RUDD/YAW         -> PWM7
 *   - ELEV/PITCH       -> PWM11
 *   - AILE/ROLL        -> PWM12
 *   - THRO/HEIGHT      -> PWM13
 *
 * PWM signal:
 *  Frequency: 50Hz => 20ms period time
 *
 * Pulse width[ms]	-> 	servo position
 *  - 0.5           ->  90 degree clockwise from center
 *  - 1.5           ->	center position
 *  - 2.5           ->	90 degree counter-clockwise from center
 *
 */

#ifndef FUNCTIONS_H
#define FUNCTIONS_H

/*
// Other hidden functions in functions.c//
static void pwn_init(void);
*/

void control(void);

#endif
