/*
 * Autonomous system - Autonom prosess for posisjonering av servicepunkt og transport av objekter
 * Part: Supply depot
 *
 * ELE300 MAS302 - Hovedprosjekt - UiA 2012 INGELEKTRO INGMEKA
 * Authors: Magne Hansen, Torsten Lyngaas, Dan Thomas Marceliussen, Edvard Gjernes
 *
 */

#include "definitions.h"

// Signals for process communication
Signal
	object_elevator,
	elevator_count,
	object_arrived_objectshelf_lift,
	object_arrived_objectshelf_magnet,
	object_left_objectshelf,
	object_on_magnet,
	no_object_on_magnet,
	drone_docked,
	magnet_inner_endpoint,
	magnet_outer_endpoint,
	belt_start,
	belt_stop,
	magnet_in,
	magnet_out,
	magnet_stop;

// Debug variables
char 	DEBUG = 1,
		INIT_DEBUG = 1,
		BELT_DEBUG = 0,
		BELTSTEPPER_DEBUG = 0,
		MAGNET_DEBUG = 0,
		MAGNETSTEPPER_DEBUG = 0,
		SENSOR_DEBUG = 0;

// Debug message configuration
void debug_set(char debug_type, char value)
{
	//usartPrint_328(0, "Debug set %d,%d\r\n", debug_type, value);
	switch(debug_type)
	{
		case 0:
			DEBUG = value;
			//usartPrint_328(DEBUG_PORT, "DEBUG: %d\r\n", value);
			break;
		case 1:
			INIT_DEBUG = value;
			//usartPrint_328(DEBUG_PORT, "INIT_DEBUG: %d\r\n", value);
			break;
		case 2:
			BELT_DEBUG = value;
			//usartPrint_328(DEBUG_PORT, "BELT_DEBUG: %d\r\n", value);
			break;
		case 3:
			//usartPrint_328(DEBUG_PORT, "BELTSTEPPER_DEBUG: %d\r\n", value);
			BELTSTEPPER_DEBUG = value;
			break;
		case 4:
			//usartPrint_328(DEBUG_PORT, "MAGNET_DEBUG: %d\r\n", value);
			MAGNET_DEBUG = value;
			break;
		case 5:
			//usartPrint_328(DEBUG_PORT, "MAGNETSTEPPER_DEBUG: %d\r\n", value);
			MAGNETSTEPPER_DEBUG = value;
			break;
		case 6:
			//usartPrint_328(DEBUG_PORT, "SENSOR_DEBUG: %d\r\n", value);
			SENSOR_DEBUG = value;
			break;
		default:
			//usartPrint_328(DEBUG_PORT, "DEBUG type not used\r\n");
			break;
	}
}

int main(void)
{
	// Variables
	static int init = 0;

	// Create process signals
	object_elevator = newSignal(0);
	elevator_count = newSignal(0);
	object_arrived_objectshelf_lift = newSignal(0);
	object_arrived_objectshelf_magnet = newSignal(0);
	object_left_objectshelf = newSignal(0);
	object_on_magnet = newSignal(0);
	no_object_on_magnet = newSignal(0);
	drone_docked = newSignal(0);
	magnet_inner_endpoint = newSignal(0);
	magnet_outer_endpoint = newSignal(0);
	belt_start = newSignal(0);
	belt_stop = newSignal(0);
	magnet_in = newSignal(0);
	magnet_out = newSignal(0);
	magnet_stop = newSignal(0);

	// Initialize
	if (!init)
	{

		init = 1;
	}

	// Cycle through all the processes in an endless loop
	while (1) 
	{
		/* Main program */
		sensormonitor();
		magnet();
		belt();
		stepper_magnet();
		stepper_belt();

		/* Testing field */
		/* Debug communiction */
		//communicator();
	}

	return 0;
} // end main
