/* 
 * System wide definitions of signals and variables
 *
 */

#ifndef DEFINITIONS_H
#define DEFINITIONS_H

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <arduino/adc.h>
#include <arduino/signals.h>


#include "testing.h"
#include "belt.h"
#include "beltstepper.h"
#include "magnet.h"
#include "magnetstepper.h"
#include "sensormonitor.h"
#include "timer_328.h"
#include "pins_328.h"
#include "usarts_328.h"

// Datatypes definitions
typedef enum {on, off} CubeturnmodeType;
typedef enum {stop, start} CorrectioncmdType;

typedef struct {
    int x;
    int y;
    int size;
} Blob;

// Signals between processes
extern Signal
	object_elevator,
	elevator_count,
	object_arrived_objectshelf_lift,
	object_arrived_objectshelf_magnet,
	object_left_objectshelf,
	object_on_magnet,
	no_object_on_magnet,
	drone_docked,
	magnet_inner_endpoint,
	magnet_outer_endpoint,
	belt_start,
	belt_stop,
	magnet_in,
	magnet_out,
	magnet_stop;

// Debug/Messages mode
extern char DEBUG,
			INIT_DEBUG,
			BELT_DEBUG,
			BELTSTEPPER_DEBUG,
			MAGNET_DEBUG,
			MAGNETSTEPPER_DEBUG,
			SENSOR_DEBUG;
#define DEBUG_PORT 0 // 0 or 3

void debug_set(char, char);

#endif
