/* 
 * Autonomous system - testing processes
 *
 */

#include "definitions.h"




/***********************************************************/
/***********************************************************/

void communicator(void)
{
	static char init = 0;
	static char i = 0;
	static char c;
    static unsigned char a[5];
    static char code = 0;
    static char value = 0;
    static char type = 0;

	if (!init)
	{
		//usartInstall(SERIAL_OUTBOUND, BAUD_RATE); // Outbound from robot (On-board Arduino)
		usartInstall_328(DEBUG_PORT, 57600); // Inbound from computer (Xbee)
		//debug_msg( "Communicator init");
		if (DEBUG && INIT_DEBUG) usartPrint_328(DEBUG_PORT, "Communicator - init\r\n");
		init = 1;
	}

	// Receive commands from computer over Xbee link
	if (usartDataIsPresent_328(DEBUG_PORT))
	{
		a[0] = '\0';
		a[1] = '\0';
		a[2] = '\0';
		a[3] = '\0';
		a[4] = '\0';

		do
		{
			c = usartRead_328(DEBUG_PORT);
			usartWrite_328(DEBUG_PORT, c);
			a[(int)i] = c;
			if (i < 5)
				i++;
		} while (c != '\n');


		code = a[0];
		type = (a[1]-'0');
		value = (a[2]-'0');

	    i = 0;

	    switch (code)
	    {

	     	case 'x':
	    		debug_set(type, value);
	    		break;
	     	default:
	     		usartPrint_328(DEBUG_PORT, "DEBUG: not viable command\r\n");
	    		break;
	    }
	}
}

/***********************************************************/
/***********************************************************/

