#ifndef USARTS_328_H_
#define USARTS_328_H_

/*
 *  'port' = 0. 'port' referer til USART nummeret
 *  Porten kan installeres.
 *  Porten kan ha forskjellige baudrate, men kun en om gangen.
 */

void usartInstall_328(int port, unsigned long baudrate);
/*
  -	Installerer buffere og initialiser usart til
	8 databits - 1 stoppbit - ingen paritet.

	Denne funksjonen m kalles fr noen andre
	funksjoner i modulen kan kalles.

	Lovlige baudrates:
	   1200, 2400, 4800, 9600, 14400, 19200, 38400,
	  56000, 57600, 76800, 115200

*/

char usartRead_328(int port);
/*
  -	Returnerer en karakter fra input-bufferet.

	Dersom input-bufferet er tomt, ventes det
	til en karakter kommer inn i bufferet.
*/

int usartDataIsPresent_328(int port);
/*
  -	Sjekker om det er noe i input-bufferet.

	Benyttes dersom det ikke er nskelig
	at programmet skal "henge" i usartRead():

	if (usartDataIsPresent())
		data = usartRead();
*/

void usartWrite_328(int port, char c);
/*
  -	Legger en karakter i ouput-bufferet.

	Karakteren blir sendt p serieporten s fort baud-rate tillater.
*/

void usartWriteString_328(int port, char string[]);
/*
  - Skriver en tekststreng i output-bufferet.

    Karakterene blir sendt p serieporten s fort baud-rate tillater.
*/


void usartPrint_328(int port, char *format, ...);
/*
  - Skriver p serieporten som definert av formatstrengen "format".

	Denne virker p samme mte som funksjonen "printf" i
	standardmodulen stdio.
	Se dokumentasjon av funksjonen "printf" i
	AVR C-library Reference Manual
*/


#endif /* USARTS_328_H_ */
