/*
 * Console communication process
 *
 */

#include <arduino/usarts.h>
#include <arduino/timer.h>
#include <string.h>

#define MAX_CMD 120
#define MAX_MSG 120

int main() {
	char c;
	static char a[MAX_CMD];
	static int i = 0;
	static int debug;

	usartInstall(0, 57600);
	usartInstall(3, 57600);
	usartPrint(0, "\r\nKonsoll starter.. ");
	startTiming();
	delay(3000);

	while (1) {
		if (usartDataIsPresent(0)) {
			c = usartRead(0);
			usartWrite(3, c);
			usartPrint(0, "\r\nUt: ");
			usartWrite(0, c);
		}
		if (usartDataIsPresent(3)) {
			do {
				c = usartRead(3);
				//usartWrite(0, c);
				a[i] = c;
				if (i < (MAX_CMD - 1))
					i++;
			} while (usartDataIsPresent(3));

			if (i == (MAX_CMD - 1)) {
				a[MAX_CMD - 1] = '\0';
			} else {
				a[i] = '\0';
			}
			i = 0;

			if (a[0] == 'D' && (a[1] == '0'  || a[1] == '1' || a[1] == '2' || a[1] == '3' || a[1] == '4' || a[1] == '5' || a[1] == '6' || a[1] == '7' || a[1] == '8' || a[1] == '9')) {
				debug = (int) ((a[1] - '0') * 10000 + (a[2] - '0') * 1000
						+ (a[3] - '0') * 100 + (a[4] - '0') * 10
						+ (a[5] - '0') * 1 );
				usartPrint(0, debug);
			} else {
				usartPrint(0, a);
			}
		}
	}

	return 0;
} // end console

