/*
 * Autonomous system - Autonom prosess for posisjonering av servicepunkt og transport av objekter
 * Part: Delivery depot
 *
 * ELE300 MAS302 - Hovedprosjekt - UiA 2012 INGELEKTRO INGMEKA
 *
 */

#include "definitions.h"

// Signals for process communication
Signal
	arm_endpoint_up,
	arm_endpoint_down,
	object_on_magnet,
	no_object_on_magnet,
	drone_docked,
	no_drone_docked,
	arm_is_up,
	arm_is_down,
	arm_up,
	arm_down,
	arm_hold;

// Debug variables
char 	DEBUG = 1,
		INIT_DEBUG = 1,
		STEPPER_DEBUG = 0,
		DEPOT_DEBUG = 0,
		SENSOR_DEBUG = 0;

// Debug message configuration
void debug_set(char debug_type, char value)
{
	//usartPrint_328(0, "Debug set %d,%d\r\n", debug_type, value);
	switch(debug_type)
	{
		case 0:
			DEBUG = value;
			//usartPrint_328(0, "Set DEBUG to : %d\r\n", value);
			break;
		case 1:
			INIT_DEBUG = value;
			//usartPrint_328(DEBUG_PORT, "Set INIT_DEBUG to : %d\r\n", value);
			break;
		case 2:
			STEPPER_DEBUG = value;
			//usartPrint_328(DEBUG_PORT, "Set STEPPER_DEBUG to : %d\r\n", value);
			break;
		case 3:
			//usartPrint_328(DEBUG_PORT, "Set DEPOT_DEBUG to : %d\r\n", value);
			DEPOT_DEBUG = value;
			break;
		case 4:
			//usartPrint_328(DEBUG_PORT, "Set SENSOR_DEBUG to : %d\r\n", value);
			SENSOR_DEBUG = value;
			break;
		default:
			//usartPrint_328(DEBUG_PORT, "DEBUG type not used\r\n");
			break;
	}
}

int main(void)
{
	// Variables
	static char init = 0;

	// Create process signals
	arm_endpoint_up = newSignal(0);
	arm_endpoint_down = newSignal(0);
	object_on_magnet = newSignal(0);
	no_object_on_magnet = newSignal(0);
	drone_docked = newSignal(0);
	no_drone_docked = newSignal(0);
	arm_is_up = newSignal(0);
	arm_is_down = newSignal(0);
	arm_up = newSignal(0);
	arm_down = newSignal(0);
	arm_hold = newSignal(1, sizeof(SwitchType));

	// Initialize
	if (!init)
	{
		init = 1;
	}

	// Cycle through all the processes in an endless loop
	while (1) 
	{
		/* Main program */
		depot();
		sensormonitor();
		stepper_arm();

		/* Testing field */
		/* Stepper motor testing processlist */
		//stepper_test();

		/* Analog sensing processlist */
		//adc_test();

		/* Debug communiction */
		//communicator();
	}

	return 0;
} // end main
