/* 
 * System wide definitions of signals and variables
 *
 */

#ifndef DEFINITIONS_H
#define DEFINITIONS_H

#include <stdlib.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <arduino/adc.h>
#include <arduino/signals.h>

#include "depot.h"
#include "sensormonitor.h"
#include "stepper_arm.h"
#include "testing.h"
#include "timer_328.h"
#include "pins_328.h"
#include "usarts_328.h"

// Datatypes definitions
typedef enum {on, off} SwitchType;



// Signals between processes
extern Signal


	arm_endpoint_up,
	arm_endpoint_down,
	object_on_magnet,
	no_object_on_magnet,
	drone_docked,
	no_drone_docked,

	arm_is_up,
	arm_is_down,
	arm_up,
	arm_down,
	arm_hold;

// Debug/Messages mode
extern char 	DEBUG,
			INIT_DEBUG,
			STEPPER_DEBUG,
			DEPOT_DEBUG,
			SENSOR_DEBUG;
#define DEBUG_PORT 0 // 0 or 3

void debug_set(char, char);

#endif
