/* ------------------------------------------------------------

Arduino ATmega328 pin layout

Module pins

  Inneholder funksjonene pinMode, digitalRead og digitalWrite
  som virker som de samme funksjonene i Arduino's programsystem.

	pinMode_328()
		Description:
		   Configures the specified pin to behave either 
		   as an input or an output.
		Syntax:
		   pinMode_328(pin, mode)
		Parameters;
			pin: the number of the pin whose mode you wish to set
			mode: either INPUT or OUTPUT (0 or 1)
		Returns:
			None 
		
	digitalWrite_328()
		Description:
			Write a HIGH or a LOW value to a digital pin.
		Syntax:
			digitalWrite_328(pin, value)
		Parameters:
			pin: the pin number
			value: HIGH or LOW (1 or 0)
		Returns:
			none

	digitalRead_328()
		Description:
			Reads the value from a specified digital pin, 
			either HIGH or LOW (1 or 0).
		Syntax:
			digitalRead_328(pin)
		Parameters:
			pin: the pin number
		Returns:
			HIGH or LOW (1 or 0)		

------------------------------------------------------------ */
#ifndef PINS_328_H_
#define PINS_328_H_

#ifndef HIGH
#define HIGH 1
#endif

#ifndef HI
#define HI 1
#endif

#ifndef LOW
#define LOW  0
#endif

#ifndef LO
#define LO  0
#endif

#ifndef INPUT
#define INPUT 0
#endif

#ifndef IN
#define IN 0
#endif

#ifndef OUTPUT
#define OUTPUT 1
#endif

#ifndef OUT
#define OUT 1
#endif


void pinMode_328(unsigned char pin, unsigned char mode);

void digitalWrite_328(unsigned char pin, unsigned char val);

int digitalRead_328(unsigned char pin);

#endif /* PINS_328_H_ */
