/*
 * Stepper motor process for the arm
 *
 * Signals controlling the stepper
 * 	arm_up -  move the arm up
 * 	arm_down - move the arm down
 * 	arm_hold(off)  - set all pins to 0
 * 	arm_hold(on) - set pins to last known pin configuration
 *
 * Signals from sensors
 *  arm_endpoint - stops the current movement of the arm (also includes a variable to see which sensor triggered)
 *
 * Signals out
 *  arm_is_up - to tell that the arm have stopped in end position up
 *  arm_is_down - to tell that the arm have stopped in end position down
 *
 */

#ifndef STEPPER_ARM_H_
#define STEPPER_ARM_H_

void stepper_arm(void);

#endif /* STEPPER_ARM_H_ */
