/*
 * Autonomous system - Autonom prosess for posisjonering av servicepunkt og transport av objekter
 * Part: Service station
 *
 * ELE300 MAS302 - Hovedprosjekt - UiA 2012 INGELEKTRO INGMEKA
 *
 */

#include "definitions.h"

// Signals for process communication
Signal
	drone_connected,
	done_charging_pin_no,
	done_charging,
	check_flag_on;

// Debug/Messages mode
char DEBUG = 1,
	 INIT_DEBUG = 1,
	 SERVICE_DEBUG = 0,
	 SENSOR_DEBUG = 0;

void debug_set(char debug_type, char value)
{
	//usartPrint_328(0, "Debug set %d,%d\r\n", debug_type, value);
	switch(debug_type)
	{
		case 0:
			DEBUG = value;
			usartPrint_328(0, "Set DEBUG to : %d\r\n", value);

			break;
		case 1:
			INIT_DEBUG = value;
			usartPrint_328(DEBUG_PORT, "Set INIT_DEBUG to : %d\r\n", value);
			break;
		case 2:
			SERVICE_DEBUG = value;
			usartPrint_328(DEBUG_PORT, "Set SERVICE_DEBUG to : %d\r\n", value);
			break;
		case 3:
			usartPrint_328(DEBUG_PORT, "Set SENSOR_DEBUG to : %d\r\n", value);
			SENSOR_DEBUG = value;
			break;
		default:
			usartPrint_328(DEBUG_PORT, "DEBUG type not used\r\n");
			break;
	}
}

int main(void)
{
	// Variables
	static int init = 0;

	// Create process signals
	//								value is 1 if it's supposed to be a charger
	//								pin 0			pin1			pin2			pin 3
	drone_connected = newSignal(4, 	sizeof(char),	sizeof(char),	sizeof(char),	sizeof(char));
	done_charging = newSignal(0);

	// Initialize
	if (!init)
	{
		init = 1;
	}

	// Cycle through all the processes in an endless loop
	while (1) 
	{
		/* Main program */
		//communication();
		//sensormonitor();
		//service();

		/* Testing field */
		//set_charge_test();
		//service_test_relee();

		service();
		sensormonitor_simulator();
	}

	return 0;
} // end main
