/* 
 * System wide definitions of signals and variables
 *
 */

#ifndef DEFINITIONS_H
#define DEFINITIONS_H

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <arduino/adc.h>
#include <arduino/signals.h>


#include "service.h"
#include "sensormonitor.h"
#include "timer_328.h"
#include "pins_328.h"
#include "usarts_328.h"
#include "testing.h"

// Signals between processes
extern Signal
	drone_connected,
	done_charging;

// Debug/Messages mode
extern char DEBUG,
			INIT_DEBUG,
			SERVICE_DEBUG,
			SENSOR_DEBUG;
#define DEBUG_PORT 0

void debug_set(char, char);



#endif
