/*
 * Autonomous system - testing processes
 *
 */

#include "definitions.h"

/***********************************************************/
/***********************************************************/

#define STEPPER_SPEED 2
#define NUM_CH 1

/*
void adc_test(void)
{

	static int SA_threshold[12] = {	0, 102, 205, 307, 409, 512, 614, 717, 819, 922, 1023 };
	static int blinking_speed[12] = {0, 10, 20 , 40, 80, 160, 320, 640, 1024, 2048, 4096 };
	static int SA_ch = 0;


	static int init = 0;
	static int current, blinking_flag, blink_speed;
	static Timer check_timer, blink_timer;

	if (!init)
	{
		check_timer = newTimer_328();
		startTimer_328(10, check_timer);
		//blink_timer = newTimer_328();
		//blink_speed = blinking_speed[6];
		startTimer_328(blink_speed,blink_timer );
		if (DEBUG) debug_msg(7); // "Sensor monitor - init";
		adcInstall(NUM_CH);
		pinMode_328(13, OUTPUT);
		digitalWrite_328(13, LOW);
		blinking_flag=0;
		init = 1;
	}

	if(timeout_328(blink_timer) && blinking_flag)
	{
		startTimer_328(blinking_speed[6],blink_timer);

		if (digitalRead_328(13))
		{
			digitalWrite_328(13, LOW);
		}
		else
		{
			digitalWrite_328(13, HIGH);
		}

	} else if(timeout_328(check_timer))
	{
		startTimer_328(10, check_timer);
		current = adcRead(SA_ch);
		for(int i = 0; i < 12; i++)
		{
			if ((i == 0) && (current <= SA_threshold[i]))
			{
				// 0 volt no blinking no light
				// don't start timer
				blinking_flag = 0;
				digitalWrite_328(13, LOW);
				i = 12;

			}
			else if ((i == 11)&&(current >= SA_threshold[i]))
			{
				// 5 volt no blinking, light on
				// don't start timer
				blinking_flag = 0;
				digitalWrite_328(13, HIGH);
				i = 12;
			}
			else if ((current <= SA_threshold[i])&&(current > SA_threshold[i-1]))
			{
				blinking_flag = 1;
				blink_speed = blinking_speed[i];
				i = 12;

			}
		}



	}



}

void stepper_test(void)
{
	static int stepper_motorpins[] = {10,11,12,13};
	static char steps[] = {0b0101, 0b0110, 0b1010, 0b1001}; // full-step
	static char seq[] = {0b1000, 0b0100, 0b0010, 0b0001}; // a single cycle sequence

	static int i = 0;
	static Timer t1;
	static int init = 0;

	if (!init)
	{
		t1 = newTimer_328();
		for (int j = 0; j < 4; j++) // pins
		{
			pinMode_328(stepper_motorpins[j], OUTPUT);
			digitalWrite_328(stepper_motorpins[j], 0);

		}
		//pinMode_328(13, OUTPUT);
		//digitalWrite_328(13, HIGH);
		//if (DEBUG) debug_msg(9); // "Stepper left - init";
		startTimer_328(STEPPER_SPEED, t1);
		init = 1;
	}



	if (timeout_328(t1))
	{

		startTimer_328(STEPPER_SPEED, t1);
		for (int j = 0; j < 4; j++) // pins
		{
			digitalWrite_328(stepper_motorpins[j], (steps[i] & seq[j]));
		}
		if (++i > (4 - 1)) i = 0;
	}

}
*/
void communication(void)
{
	static char init = 0;
	static char i = 0;
	static char c;
    static unsigned char a[5];
    static char code = 0;
    static char value = 0;
    static char type = 0;


	if (!init)
	{
		//usartInstall(SERIAL_OUTBOUND, BAUD_RATE); // Outbound from robot (On-board Arduino)
		usartInstall_328(DEBUG_PORT, 57600); // Inbound from computer (Xbee)
		//debug_msg( "Communicator init");
		if (DEBUG && INIT_DEBUG) usartPrint_328(DEBUG_PORT, "DEBUG: Communicator - init\r\n");
		init = 1;
	}

	// Receive commands from computer over Xbee link
	if (usartDataIsPresent_328(DEBUG_PORT))
	{
		a[0] = '\0';
		a[1] = '\0';
		a[2] = '\0';
		a[3] = '\0';
		a[4] = '\0';

		do
		{
			c = usartRead_328(DEBUG_PORT);
			usartWrite_328(DEBUG_PORT, c);
			a[(int)i] = c;
			if (i < 5)
				i++;
		} while (c != '\n');


		code = a[0];
		type = (a[1]-'0');
		value = (a[2]-'0');

	    i = 0;

	    switch (code)
	    {

	     	case 'x':
	    		debug_set(type, value);
	    		break;
	     	default:
	     		usartPrint_328(DEBUG_PORT, "DEBUG: not viable command\r\n");
	    		break;
	    }
	}
}

#define CHARGER_2_3_RELEE_PIN 10
#define CHARGER_4_1_RELEE_PIN 11

void set_charge_test(void)
{
	static unsigned char vss_pin_no[4] = { 9, 7, 5, 3 };

	//Charger pins
	static unsigned char charge_pin_no[4] = { 8, 6, 4, 2 };

	static char init = 0;
	static char j = 0;
	static Timer t1;

	if(!init)
		{
			if (DEBUG && INIT_DEBUG) usartPrint_328(DEBUG_PORT, "S - init\r\n");
			for(int i = 0; i < 4; i++)
			{
				pinMode_328(vss_pin_no[i], OUTPUT);
				digitalWrite_328(vss_pin_no[i], LOW);
				pinMode_328(charge_pin_no[i], OUTPUT);
				digitalWrite_328(charge_pin_no[i], LOW);

			}

			pinMode_328(CHARGER_2_3_RELEE_PIN, OUTPUT);
			digitalWrite_328(CHARGER_2_3_RELEE_PIN, LOW);
			pinMode_328(CHARGER_4_1_RELEE_PIN, OUTPUT);
			digitalWrite_328(CHARGER_4_1_RELEE_PIN, LOW);
			t1 = newTimer_328();
			startTimer_328(2000, t1);
			init = 1;
		}

	if(timeout_328(t1))
	{

		switch(j)
		{
			case 0:
				startTimer_328(2000, t1);
				digitalWrite_328(CHARGER_2_3_RELEE_PIN, HIGH);
				j++;
				break;
			case 1:
				startTimer_328(2000, t1);
				digitalWrite_328(vss_pin_no[0], HIGH);

				j++;
				break;
			case 2:
				digitalWrite_328(charge_pin_no[1], HIGH);
				digitalWrite_328(charge_pin_no[2], HIGH);
				digitalWrite_328(charge_pin_no[3], HIGH);
				break;

		}

	}

}
/***********************************************************/
/***********************************************************/

void sensormonitor_simulator(void)
{
	static Timer t1;
	static char init = 0;
	static char i = 0;
	static char order = 0;
	static char value[2] = {0,1};
	// Initialize
	if(!init)
	{
		t1 = newTimer_328();
		init = 1;
		startTimer_328(100, t1);
		sendSignal(drone_connected, &value[1], &value[1], &value[1], &value[0]);
	}

	if (timeout_328(t1))
	{ /*
		switch(order)
		{
			case 0:
				//startTimer_328(10000, t1);
				sendSignal(drone_connected, 1, 1, 1, 0);
				//order ++;
				break;
			case 1:
				startTimer_328(4000, t1);
				sendSignal(done_charging);
				order++;
				break;
			case 2:
				startTimer_328(10000, t1);
				sendSignal(drone_connected, 0, 1, 1, 1);
				order ++;
				break;
			case 3:
				startTimer_328(4000, t1);
				sendSignal(done_charging);
				order++;
				break;
			case 4:
				startTimer_328(10000, t1);
				sendSignal(drone_connected, 1, 0, 1, 1);
				order ++;
				break;
			case 5:
				startTimer_328(4000, t1);
				sendSignal(done_charging);
				order++;
				break;
			case 6:
				startTimer_328(10000, t1);
				sendSignal(drone_connected, 1, 1, 0, 1);
				order ++;
				break;
			case 7:
				startTimer_328(4000, t1);
				sendSignal(done_charging);
				order = 0;
				break;
		}
		*/
	}

}
